<!DOCTYPE html>
<html>
  <head>
    <link rel="stylesheet" type="text/css" href="https://pyscript.net/alpha/pyscript.css"/>
    <link rel="stylesheet" type="text/css" href="static/style.css"/>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>DRB Python Training</title>
    <script defer src="https://pyscript.net/alpha/pyscript.js"></script>
    <script src="static/check.js"></script>

    <title>
        <b>DRB Python Training</b>
    </title>
</head>

<py-env>
  - importlib-metadata
  - PyYaml
  - 'static/lib/drb-1.0.8+3.gd962af8.dirty-py3-none-any.whl'
</py-env>


  <body class="my_body">
    <h1 class="big_title">Drivers & Factory</h1>

    <br />
    <br />

    <h2 class="chapter">Drivers</h2>

    <br />
    <br />

    <table>
      <thead>
        <tr>
          <th>Driver</th>
          <th>Version</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>File</td>
          <td>1.0.1</td>
          <td>
            Implementation allowing DRB entering directory and seeing files.
          </td>
        </tr>
        <tr>
          <td>Xml</td>
          <td>1.0.3</td>
          <td>Implementation allowing DRB browsing XML content.</td>
        </tr>
        <tr>
          <td>Json</td>
          <td>1.0.1</td>
          <td>Implementation allowing DRB browsing JSON data structure.</td>
        </tr>
        <tr>
          <td>Ftp</td>
          <td>1.0.0</td>
          <td>Implementation allowing DRB browse inside ftp protocol.</td>
        </tr>
        <tr>
          <td>Http</td>
          <td>1.0.7</td>
          <td>Implementation allowing DRB browse inside http protocol.</td>
        </tr>
        <tr>
          <td>Image</td>
          <td>1.0.1</td>
          <td>Implementation allowing DRB browsing image metadata and data.</td>
        </tr>
        <tr>
          <td>Java</td>
          <td>1.0.0</td>
          <td>Implementation allowing DRB using java DRB nodes.</td>
        </tr>
        <tr>
          <td>Netcdf</td>
          <td>1.0.1</td>
          <td>Implementation allowing DRB browsing netcdf contents.</td>
        </tr>
        <tr>
          <td>Odata</td>
          <td>1.0.5</td>
          <td>Implementation allowing DRB to access OData service.</td>
        </tr>
        <tr>
          <td>Swift</td>
          <td>1.0.1</td>
          <td>Implementation allowing DRB browsing OpenStack Swift service.</td>
        </tr>
        <tr>
          <td>Tar</td>
          <td>1.0.0</td>
          <td>Implementation allowing DRB browse tar contents.</td>
        </tr>
        <tr>
          <td>Webdav</td>
          <td>1.0.0</td>
          <td>Implementation allowing DRB browing webdav service.</td>
        </tr>
        <tr>
          <td>Zarr</td>
          <td>1.0.0</td>
          <td>Implementation allowing DRB browsing zarr dataset content.</td>
        </tr>
        <tr>
          <td>Zip</td>
          <td>1.0.1</td>
          <td>
            Implementation allowing DRB browsing and extracting zip content.
          </td>
        </tr>
        <tr>
          <td>Aws3</td>
          <td>1.0.0</td>
          <td>Amazon S3 implementation with Drb data model.</td>
        </tr>
        <tr>
          <td>Wxs</td>
          <td>1.0.0</td>
          <td>
            Abstract basic implementation for OWS services implementations.
          </td>
        </tr>
      </tbody>
    </table>
    <br />
    <br />

    <h2 class="chapter">Factory</h2>

    <br />
    <br />

    <img src="static/images/Factory.png">

    <br />
    <br />

    <p>The user gives a path to a certain data to the resolver.
      The factory will check if this path matches with a certain driver.
      And then create the node corresponding to this driver and return it. <br/>You can create and call the resolver using this:
    </p>


    <py-repl>
from drb.factory import DrbFactoryResolver

# Instantiate the resolver
factory = DrbFactoryResolver()
    </py-repl>

    <br/>
  
    <p>
      After creating you resolver you can call the create method
    </p>
    <p class="code">    create(self, source: Union[DrbNode, str]) -> DrbNode
    </p>

    <br />
    <br />

    <pre>
      <code class="language-python"> 
from drb.factory import DrbFactoryResolver\n<br/>
from drb.utils.logical_node import DrbLogicalNode<br>
from drb.factory import DrbFactoryResolver<br>
from drb_impl_xml import XmlNodeFactory<br>
from drb.factory import DrbFactoryResolver<br>
from drb_impl_netcdf import DrbNetcdfFactory<br>
import io<br>
<br>
factory = DrbNetcdfFactory()<br>

# Create the node corresponding to the Netcdf data<br>
node = factory.create("/data/italy/S5P_OFFL_L2__NO2____20200201T112236_20200201T130406_11933_01_010302_20200204T163837.nc")</code >  
  </pre>     


<p>
  Here we used the DrbNetcdfFactory() by giving the path to the netcdf file to create a DrbNetcdfNode.<br>
  With the node we can now navigate in the file and extract data from it for example:
</p>
<pre>
  <code class="language-python"> 
print(node['root']['PRODUCT']['dimensions']['scanline'].value) ==> 4173
  </code>
</pre>
<br/>
<br/>
<h2 class="chapter">DrbFactoryResolver</h2>
<br/>

<pre>
  <code class="language-python"> 
from drb_impl_http import DrbHttpFactory
from drb_impl_json import JsonNodeFactory

# Use the DrbHttpFactory on the Url to create the HttpNode corresponding to the data
http = DrbHttpFactory().create("https://gitlab.com/drb-python/impl/json/-/raw/main/tests/resources/geo.json")

# And create the JsonBaseNode corresponding to the file on gitlab
ret = JsonNodeFactory().create(http)

print(ret[0].value)
    </code>
</pre>
<p>
  We can see in this example, to extract data from a Json file wich is on gitlab,<br/> 
  I first create a DrbHttpNode by calling the DrbHttpFactory() and then with this node <br/>
  I used the JsonNodeFactory() to read the Json file.<br/>
  But there is an easier way to do it by using directly the DrbFactoryResolver().
</p>
<pre>
  <code class="language-python"> 
from drb.factory import DrbFactoryResolver

# One line with the resolver
ret = DrbFactoryResolver().create("https://gitlab.com/drb-python/impl/json/-/raw/main/tests/resources/geo.json")

print(ret[0].value)
    </code>
</pre>

<br/>
<br/>
    <footer>
      <p><a href="topics.html">Topics</a></p>
      <p><a href="/">Home Page</a></p>
    </footer>
    <footer id="err-div" class="bg-red-700 text-white text-center border-t-4 border-green-500 fixed inset-x-0 bottom-0 p-4 hidden"/>

  </body>
</html>
